<?php
/**
 * @file
 */

namespace Drupal\neo4j_connector\Factory;

use Everyman\Neo4j\Client;
use Everyman\Neo4j\Transport\Curl;

class Neo4JClientFactory {

  /**
   * @var Client
   */
  private $client;

  public function get() {
    $config = \Drupal::config('neo4j_connector.site');

    $host = $config->get('host');
    $port = $config->get('port');

    $transport = new Curl($host, $port);

    $username = $config->get('username');
    $password = $config->get('password');
    if ($username && $password) {
      $transport->setAuth($username, $password);
    }

    $this->client = new Client($transport, $port);

    return $this->client;
  }

}
